<?php

namespace Drupal\transform_api\Exception;

use Drupal\Core\Url;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Throwable;

class RedirectTransformationException extends ResponseTransformationException {

  public function __construct($route_name, array $route_parameters = [], array $options = [], $status = 302, ?Throwable $previous = NULL) {
    $options['absolute'] = TRUE;
    $options['query']['format'] = 'json';
    $url = Url::fromRoute($route_name, $route_parameters, $options)->toString();
    $response = new RedirectResponse($url, $status);
    $message = 'Redirecting to ' . $url;
    parent::__construct($response, $message, $previous);
  }

}
