<?php

namespace Drupal\transform_api;

use Drupal\Core\Field\FieldItemListInterface;

trait FieldFormatterWrapper {

  protected $transformMode = 'default';

  public function getTransformMode() {
    return $this->viewMode;
  }

  public function prepareTransform(array $entities_items) {
    /** @var \Drupal\Core\Field\FormatterInterface $formatter */
    $formatter = $this;
    $formatter->prepareView($entities_items);
  }

  public function transform(FieldItemListInterface $items, $langcode = NULL) {
    $transform = $this->view($items, $langcode);

    $transform['#transform'] = $transform['#theme'] ?? '';
    unset($transform['#theme']);
    $transform['#collapse'] = !($transform['#is_multiple'] ?? FALSE);

    return $transform;
  }

  public function viewElements(FieldItemListInterface $items, $langcode) {
    return $this->transformElements($items, $langcode);
  }

}
