<?php

namespace Drupal\transform_api\Transform;

use Drupal\transform_api\Entity\TransformBlock;
use Drupal\transform_api\TransformBlockInterface;

class BlockTransform extends PluginTransformBase {

  protected ?TransformBlockInterface $block = NULL;

  public function __construct($id) {
    $this->values = [
      'id' => $id
    ];
  }

  public function getTransformType() {
    return 'block';
  }

  public function setBlock(TransformBlockInterface $block) {
    $this->block = $block;
  }

  public function getBlock(): TransformBlockInterface|null {
    if (empty($this->block)) {
      $this->block = TransformBlock::load($this->getValue('id'));
    }
    return $this->block;
  }

  public static function createFromBlock(TransformBlockInterface $block) {
    $transform = new self($block->id());
    $transform->setBlock($block);
    return $transform;
  }

}
